clear all;
close all;
data1 = [1,2,-2,4;2,3,4,2;3,4,5,6;4,5,6,1];
[M,N] = size(data1);
% subtract off the mean for each dimension
mn = mean(data1,2);
data = data1 - repmat(mn,1,N);
% construct the matrix Y
Y = data' / sqrt(N-1);
% SVD does it all
[u,S,PC] = svd(Y);
% calculate the variances
S = diag(S);
V = S .* S;
% project the original data
signals = PC' * data;
[coef,scores] = pca(data1);
T = PC*signals + repmat(mn,1,N);
